% Various utilities for the RBF package.
%
%   conf_check   - Check the legality of a configuration against its specification.
%   conf_print   - Print a configuration specification, or one part of it.
%   get_data     - Get training or test data for a simulated learning problem.
%   get_fig      - Create a new figure or grab an old one with the same name.
%   get_tmr      - Setup a graphical timer to monitor the progress of a loop.
%   grow_tree    - Grow a regression tree by recursive splitting.
%   inc_tmr      - Increment a graphical timer during one iteration of a loop.
%   isstring     - Returns true if the argument is a row vector of characters.
%   plot_ras     - Plots a Rasmussen diagram to compare different methods.
%   pred_tree    - Predict using a tree structure returned from grow_tree.
%   rbf_dm       - Generate a design matrix using RBF functions.
%   rbf_ver      - Prints information about the current RBF package.
%   run_demo     - Runs one of the demos defined in ../demo.
%   tree_rbf     - Translates a tree into RBF centres and radii.
%
